os.cpu(333)
buttons.read()

--Guardar Configuracion en el menu
pathini="ms0:/ONEMENU.INI"
function write_table(pathini, tb)
    local file = io.open(pathini, "w+")
	file:write("config = {\n")
	for s,t in pairs(tb) do
		if type(t) == "string" then
		file:write(string.format('"%s",\n', tostring(t)))
		else
		file:write(string.format('%s,\n', tostring(t)))
		end
	end
	file:write("}")
	file:close()
end

--1 saves, 2 vhbl, 3 cats, 4 slides, 5 scan hiddens, 6 show hiddens, 7 DeletListHiddens
--8 Show PICs, 9 Barcolor, 10 square, 11 triangle, 12 circle, 13 cross, 14 ListHiddens

config = {true,true,false,true,false,false,false,false,1,"","","","",""}--Supertable

if files.exists(pathini) then dofile(pathini)
else write_table(pathini, config) end

--Boot
if buttons.held.square and #config[10] > 1 then game.launch(config[10])
elseif buttons.held.triangle and #config[11] > 1 then game.launch(config[11])
elseif buttons.held.circle and #config[12] > 1 then game.launch(config[12])
elseif buttons.held.cross and #config[13] > 1 then game.launch(config[13])
end

background = image.load("BACK.PNG")
default_icon = image.load("ICODEF.PNG")
--------------------Scanning-----------------------------------------------------------------
-- Languague
if files.exists("LANG.LUA") then dofile("LANG.LUA") else dofile("ING.LUA") end

dofile("SCAN.LUA") --Functions SCAN

function init_msg(txt)
	background:blit(0,0)
	screen.print(10,5,txt,0.5)
	screen.print(10,255,os.cfw(),0.5)
	screen.flip()
	os.delay(5)
end

--[[
	games[1] for ISO/CSO and PSN (UG & EG)
	games[2] for HBs (MG)
	games[3] for PS1 (ME)
	games[4] for .Zips
	games[5] for Hiddens Hbs
]]

games = { {},{},{},{},{} }--SuperTable
local msg=""

if config[1] then						--Scanning for Zips/Iso/Cso in SAVEDATA
	msg=strings.saves
	init_msg(msg)
	scanning_saves()
end

if config[2] then						--Scanning for HBs in PSP/VHBL
	msg=msg.."\n"..strings.vhbl
	init_msg(msg)
	scanning_pbps("ms0:/PSP/VHBL/")
end

--Scanning for iso/cso in ms0:/ISO
if os.cfw()~="VHBL" then
	if config[3] then msg=msg.."\n"..strings.catiso else msg=msg.."\n"..strings.iso end
	init_msg(msg)
	scanning_isos("ms0:/ISO")
	if hw.getmodel() =="Go" then scanning_isos("ef0:/ISO") end
end

--Scanning for HBs in PSP/GAME
if config[3] then msg=msg.."\n"..strings.gamecat else msg=msg.."\n"..strings.game end
init_msg(msg)
scanning_pbps("ms0:/PSP/GAME/")
if hw.getmodel() =="Go" then scanning_pbps("ef0:/PSP/GAME/") end

for i=1,#games do
	games[i].ini=1
	games[i].sel=1
	if #games[i] > 5 then games[i].lim=5 else games[i].lim=#games[i] end
end

if #games[1]>0 then cat=1 else cat=2 end

default_icon,msg=nil,nil
collectgarbage("collect")

Seccion,trans = 1,0
dofile("SHELL.LUA")

if config[8] then pic1=game.getpic1(games[cat][1].path) end-- 1er PIC1

while true do
	buttons.read()

	if pic1 then pic1:center() pic1:blit(240,136,trans) -- Background or PIC1
	elseif background then background:blit(0,0)	end

	if config[4] then posy=50 else posy=195 end--Slides

	BarColor = col[config[9]]--Barcolor

	if Seccion == 1 then--Games Menu
		main_draw()
		main_controls()
	elseif Seccion == 2 then--Config Menu
		menu_draw()
		menu_controls()
	end
	if buttons.select and Seccion == 1 then--Explorer
		explorer.main()
	end

	screen.flip()
	if trans < 255 then trans = trans + 5 end
end
